package team.frc.morpheus.robot;

import java.util.Optional;

import edu.wpi.first.wpilibj.BuiltInAccelerometer;
import edu.wpi.first.wpilibj.PIDSource;
import edu.wpi.first.wpilibj.PIDSourceType;
import team.frc.morpheus.util.transform.Point3D;
import team.frc.morpheus.util.transform.TransformMatrix;

public class GravityFeedbackSource implements PIDSource {

    private BuiltInAccelerometer accelerometer;
    private TransformMatrix mat;
    private static Optional<GravityFeedbackSource> instance = Optional.empty();

    private GravityFeedbackSource() {
        instance = Optional.of(this);
        accelerometer = new BuiltInAccelerometer();
        mat = TransformMatrix.rotateX(60);
    }

    public static synchronized GravityFeedbackSource getInstance() {
        return instance.orElseGet(GravityFeedbackSource::new);
    }

    @Override
    public double pidGet() {
        return mat.apply(new Point3D(accelerometer.getX(), accelerometer.getY(), accelerometer.getZ())).z;
    }

    @Override
    public void setPIDSourceType(PIDSourceType pidSource) {
    }

    @Override
    public PIDSourceType getPIDSourceType() {
        return PIDSourceType.kDisplacement;
    }
}
