/*----------------------------------------------------------------------------*/
/* Copyright (c) 2017-2018 FIRST. All Rights Reserved.                        */
/* Open Source Software - may be modified and shared by FRC teams. The code   */
/* must be accompanied by the FIRST BSD license file in the root directory of */
/* the project.                                                               */
/*----------------------------------------------------------------------------*/

package team.frc.morpheus.robot;

import team.frc.morpheus.robot.commands.shifter.Shift;
import team.frc.morpheus.robot.subsystems.Shifter;
import team.frc.morpheus.util.input.Gamepad360;

/**
 * This class is the glue that binds the controls on the physical operator
 * interface to the commands and command groups that allow control of the robot.
 */
public class OI {

    public Gamepad360 driver, operator;

    public enum Driver {
        DALER,
        ISAAC,
        GARRETT
    }

    public OI() {
        driver = new Gamepad360(0);
        operator = new Gamepad360(1);

        driver.buttonLB.whileHeld(new Shift(Shifter.Gear.TORQUE));
        driver.buttonLB.whenReleased(new Shift(Shifter.Gear.SPEED));
    }
}

