package team.frc.morpheus.robot.commands.drivebase;

import java.util.function.Supplier;


/**
 * Allows to insert a "snippet" of driver control into auto (such as during
 * the sandstorm period in the 2019 game) that ends upon the supplied condition.
 */
public class DriverControlSnippet extends DriverControl {

   private Supplier<Boolean> condition;

    public DriverControlSnippet(Supplier<Boolean> condition){
        super();
        this.condition = condition;

    }

    @Override
    protected boolean isFinished() {
        return condition.get();
    }
}
