package team.frc.morpheus.robot.commands.drivebase;

import edu.wpi.first.wpilibj.command.Command;
import team.frc.morpheus.robot.Robot;
import team.frc.morpheus.util.input.Coordinate;
import team.frc.morpheus.robot.subsystems.DriveBase;

/**
 *
 */
public class TurnInPlace extends Command {
    double targetPosition, currentPosition, speed;
    boolean reverse = false;

    public TurnInPlace(double degrees, double speed) {
        requires(Robot.driveBase);
        this.speed = speed;
        targetPosition = (degrees * Math.PI / 180) * DriveBase.WIDTH / 2 + Robot.driveBase.getRightPosition();
        if (degrees < 0) reverse = true;
    }

    // Use requires() here to declare subsystem dependencies
    // eg. requires(chassis);
    // Called just before this Command runs the first time
    protected void initialize() {
        Robot.driveBase.set(new Coordinate.Polar(reverse ? 0 : Math.PI, speed));
    }

    // Called repeatedly when this Command is scheduled to run
    protected void execute() {
        currentPosition = Robot.driveBase.getRightPosition();
        System.out.println("This is left: " + Robot.driveBase.getLeftPosition());
        System.out.println("This is right: " + Robot.driveBase.getRightPosition());
    }

    // Make this return true when this Command no longer needs to run execute()
    protected boolean isFinished() {
        if (reverse) {
            return currentPosition <= targetPosition;
        } else {
            return currentPosition >= targetPosition;
        }
    }

    // Called once after isFinished returns true
    protected void end() {
        Robot.driveBase.set(new Coordinate.Cartesian(0, 0));
    }
}
