package team.frc.morpheus.robot.commands.drivebase.features;

import team.frc.morpheus.robot.Robot;
import team.frc.morpheus.robot.RobotMap;
import team.frc.morpheus.robot.commands.drivebase.DriverControl;
import team.frc.morpheus.util.input.Coordinate;
import team.frc.morpheus.vision.limelight.DoubleTargetTrackerLimelight;

public class AssistedEnhanced implements DriverControl.Feature {

    private double accumulator, oldError;

    public AssistedEnhanced() {
        accumulator = 0;
        oldError = 0;
    }

    @Override
    public Coordinate apply(Coordinate in) {
        double correctionExtent = Robot.m_oi.driver.getRightTrigger();
        double error = DoubleTargetTrackerLimelight.getLRAdjustment();
        double correction = error * RobotMap.ASSISTED_DRIVING_KP + accumulator * RobotMap.ASSISTED_DRIVING_KI + (error - oldError) * RobotMap.ASSISTED_DRIVING_KD;
        accumulator += error;
        oldError = error;
        return new Coordinate.Cartesian(in.x() + correctionExtent * correction, in.y());

    }
}
