package team.frc.morpheus.robot.subsystems;

import edu.wpi.first.wpilibj.Solenoid;
import edu.wpi.first.wpilibj.command.Subsystem;
import team.frc.morpheus.robot.RobotMap;

import java.util.Optional;

public class Shifter extends Subsystem {
    private Solenoid pancake;
    private static Optional<Shifter> instance = Optional.empty();

    public enum Gear {
        TORQUE,
        SPEED
    }

    private Shifter() {
        instance = Optional.of(this);
        pancake = new Solenoid(RobotMap.PCM, RobotMap.SHIFT);
        shift(Gear.SPEED);
    }

    public static synchronized Shifter getInstance() {
        return instance.orElseGet(Shifter::new);
    }

    public void shift(Gear gear) {
        switch (gear) {
            case TORQUE:
                pancake.set(false);
                break;
            default:
            case SPEED:
                pancake.set(true);
                break;
        }
    }

    public Gear getGear() {
        if (pancake.get()) return Gear.SPEED;
        else return Gear.TORQUE;
    }

    @Override
    protected void initDefaultCommand() {
    }
}
