package team.frc.morpheus.util.transform;

public class Point3D {
  public final double x, y, z, h;
  public Point3D(double x, double y, double z) {
    this.x = x;
    this.y = y;
    this.z = z;
    this.h = 1;
  }
  public Point3D(double x, double y, double z, double h) {
    this.x = x;
    this.y = y;
    this.z = z;
    this.h = h;
  }

  // ToDo: verify that between() and fuzzyEq() actually work
  private static boolean between(double x, double l, double h) {
    return x >= l && x <= h;
  }

  private static boolean fuzzyEq(double a, double b, double tolerance) {
    return between(a, b * (1 - tolerance), b * (1 + tolerance));
  }

  public boolean fuzzyEq(Point3D other) {
    return fuzzyEq(other, 0.0001);
  }

  public boolean fuzzyEq(Point3D other, double tolerance) {
    return fuzzyEq(x, other.x, tolerance) &&
           fuzzyEq(y, other.y, tolerance) &&
           fuzzyEq(z, other.z, tolerance) &&
           fuzzyEq(h, other.h, tolerance); 
  }

  @Override
  public String toString() {
    return String.format("(%f, %f, %f)", x, y, z);
  }
}